diff -Naur --exclude=CVS --exclude=configs linux/hpc/mig.c linux-openmosix/hpc/mig.c
--- linux/hpc/mig.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/mig.c	2004-04-05 17:39:45.000000000 +0200
@@ -0,0 +1,1580 @@
+/* Changes since Feb 12, 2002 by Moshe Bar (moshe@moelabs.com)
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Oren Laadan, Amnon Shiloh, Moshe Bar
+ */
+
+#include <linux/sched.h>
+#include <linux/ptrace.h>
+#include <hpc/routines.h>
+#include <linux/hpc.h>
+#include <linux/personality.h>
+#include <linux/hpcctl.h>
+#include <linux/mm.h>
+#include <linux/swap.h>
+#include <linux/swapctl.h>
+#include <linux/highmem.h>
+#include <hpc/protocol.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+#include <hpc/defs.h>
+#include <hpc/hpcversion.h>
+#include <asm/uaccess.h>
+#include <linux/smp_lock.h>
+#include <linux/stddef.h>
+#include <asm/softirq.h>
+#include <asm/mman.h>
+#include <asm/mmu_context.h>
+#include <asm/ldt.h>
+#include <linux/vmalloc.h>
+#include <asm/desc.h>
+#include <linux/module.h>
+#include <asm/processor.h>
+#include <asm/i387.h>
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
+static int mig_remote_receive_proc(void *);
+static int mig_local_passto_remote(int, int);
+static int mig_remote_passto_remote(int, int);
+static int mig_remote_passto_local(int, int);
+
+#define MIGDSTR "oM_migd"
+static char REMOTESTR[] = "remote";
+static char REMOTESTR2[] = "remote(%d)";
+
+int mig_daemon_active = 0;
+struct task_struct *mig_proc = NULL;
+
+int
+mosix_mig_daemon(void *dummy)
+{
+	struct task_struct *p = current;
+	mosix_link *mlink;
+	mosix_addr saddr;
+	int error;
+
+	common_daemon_setup(MIGDSTR, 0);
+	p->mosix.dflags |= DREMOTEDAEMON;
+	init_guest_user_struct();
+	p->rlim[RLIMIT_STACK].rlim_cur = p->rlim[RLIMIT_STACK].rlim_max;
+	lock_mosix();
+	mig_proc = p;
+	unlock_mosix();
+
+ restart:
+	wait_for_mosix_configuration(&mig_daemon_active);
+	error = 0;
+	if (!p->mosix.contact &&
+		!(p->mosix.contact = comm_open(COMM_MIGD, 0, 0)))
+		{
+			if(PE)
+				printk(MIGDSTR ": failed to open migration service"
+					   " -- retrying\n");
+			spin_lock_irq(&p->sigmask_lock);
+			flush_signals(p);
+			spin_unlock_irq(&p->sigmask_lock);
+			set_current_state(TASK_INTERRUPTIBLE);
+			schedule_timeout(HZ);
+			goto restart;
+		}
+
+	while (1)
+		{
+			if(!PE)
+				{
+					comm_close(NULL);
+					goto restart;
+				}
+
+			error = comm_accept(p->mosix.contact, &mlink, &saddr, 0UL);
+			if (error == -EINTR || error == -ERESTART || error == -EAGAIN
+				|| error == -ERESTARTSYS || error == -EDIST)
+				{
+					spin_lock_irq(&p->sigmask_lock);
+					flush_signals(p);
+					spin_unlock_irq(&p->sigmask_lock);
+					continue;
+				}
+			else if (error)
+				{
+					printk("%s: failed to accept connection (err = %d)"
+						   " - re-initializing the servicei now\n", MIGDSTR, error);
+					comm_close(NULL);
+					goto restart;
+				}
+
+			if(!PE || mosadmin_mode_block)
+				{
+					comm_close(mlink);
+					continue;
+				}
+
+			current->mosix.deppe = comm_getpeer(mlink);
+			error = user_thread(mig_remote_receive_proc, (void *)mlink, 0);
+			if (error < 0)
+				{
+					comm_close(mlink);
+					continue;
+				}
+		}
+}
+
+static int
+mig_remote_receive_proc(void *ptr)
+{
+	struct mosix_link *contact = (struct mosix_link *)ptr;
+	struct mosix_link *remlink = NULL;
+	struct task_struct *p = current;
+	struct mosix_task *m = &p->mosix;
+	struct mig_request_h *mrp;
+	int type;
+	int error;
+	int reply = 0;
+	unsigned int load_came_in = 0;
+
+	memcpy(p->comm, REMOTESTR, sizeof(REMOTESTR));
+	p->mosix.stay = 0;
+	comm_use(p, contact);
+
+	lighter_sleep();
+	if((error = obtain_mm()))
+		goto failed;
+
+	if (p->mosix.dflags & DREMOTE)
+		p->mosix.dflags |= DPSYNC;
+	if ((error = mig_recv_request(&mrp)))
+		goto failed;
+	type = mrp->request_type;
+	if(type != DEPUTY_PROBE)
+		load_came_in = 1;
+
+	if(mrp->wp_works_ok && !boot_cpu_data.wp_works_ok)
+		reply = -ENOEXEC;
+
+	set_personality(mrp->personality);
+	if(current->personality != mrp->personality)
+		reply = -EDIST;
+	comm_free((void *) mrp);
+
+	if (type == DEPUTY_PROBE && reply == 0) {
+		mosix_addr sa;
+
+		/*
+		 * prepare another mosix_link for the REMOTE and send its
+		 * address through the DEPUTY.
+		 */
+
+		remlink = comm_open(COMM_ACCEPT, &sa, comm_remote_timo);
+		if (!remlink) {
+			reply = -EDIST;
+			goto send_reply;
+		}
+		if ((error = comm_send(MIG_REQUEST|REPLY, (void *)&reply,
+							   sizeof(int), (void *)&sa, sizeof(sa), 0)))
+			goto failed;
+		comm_use(p, remlink);
+		reply = mig_recv_request(&mrp);
+
+		/* 'remlink' was possibly switched by comm_recv(): */
+		remlink = p->mosix.contact;
+
+		if (reply)
+			goto failed;
+		load_came_in = 1;
+		comm_free((void *) mrp);
+		goto send_reply;
+	} else {
+	send_reply:
+		if ((error = comm_send(MIG_REQUEST|REPLY, (void *)&reply,
+							   sizeof(int), NULL, 0, 0)))
+			goto failed;
+	}
+
+	if (reply)
+		goto failed;
+
+
+	error = mig_do_receive();
+
+	if (remlink) {
+		comm_use(p, contact);
+		comm_close(remlink);
+	}
+	if (error)
+		{
+			end_coming_in(error);
+			m->pages_i_bring = 0;
+			remote_disappear();
+		}
+	mosix_clear_statistics();
+	end_coming_in(0);
+	m->pages_i_bring = 0;
+#ifdef CONFIG_MOSIX_DFSA
+	tell_process(p, DREQ_NOTUPTODATE);
+	dfsa_tinit();
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef SHOW_MIGRATIONS
+	if(SHOW_MIGRATIONS)
+		printk("Process migration occured now...\n");
+#endif /* SHOW_MIGRATIONS */
+	kickstart();
+	panic("kickstart returned");
+	/*NOTREACHED*/
+
+ failed:
+	if (load_came_in)
+	{
+		end_coming_in(-EDIST);	/* any error would do */
+		m->pages_i_bring = 0;
+	}
+	if (remlink) {
+		comm_use(p, contact);
+		comm_close(remlink);
+	}
+	do_exit(SIGKILL);
+	/*NOTREACHED*/
+}
+
+void
+follow_whereto()
+{
+	int t;
+	register struct task_struct *p = current;
+
+	spin_lock_irq(&whereto_lock);
+	t = p->mosix.whereto;
+	p->mosix.whereto = 0;
+	spin_unlock_irq(&whereto_lock);
+	if(!t)
+		return;
+	if(t > 0 || t == GOBACKHOME || t == MUSTGOHOME)
+		passto(t, 0);
+	else if(p->mosix.dflags & DDEPUTY)
+		coordinate(t, 0);
+	else
+		consider(t, NULL);
+}
+
+int
+passto(int whereto, int reason)
+{
+	register struct task_struct *p = current;
+	int error;
+
+
+	if (!PE)
+		return (whereto && whereto != GOBACKHOME &&
+				whereto != MUSTGOHOME ? -EDIST : 0);
+	if (whereto == MUSTGOHOME)
+		{
+			whereto = GOBACKHOME;
+			p->mosix.dflags |= DMUSTBEBACK;
+		}
+#ifdef CONFIG_MOSIX_CHEAT_MIGSELF
+	if (whereto == GOBACKHOME)
+		{
+			if(!p->mosix.whereami)
+				{
+					p->mosix.dflags &= ~DMUSTBEBACK;
+					return(0);
+				}
+			whereto = 0;
+		}
+#else
+	if (whereto == GOBACKHOME || whereto == PE)
+		whereto = 0;
+	if (whereto == p->mosix.whereami)
+		{
+			p->mosix.dflags &= ~DMUSTBEBACK;
+			return(0);
+		}
+#endif /* CONFIG_MOSIX_CHEAT_MIGSELF */
+	if (whereto && ((p->mosix.stay & DSTAY) || !mos_to_net(whereto, 0)))
+		return (-EDIST);
+
+
+	spin_lock_irq(&runqueue_lock);
+	p->mosix.dflags |= DPASSING;
+	spin_unlock_irq(&runqueue_lock);
+	store_common_ps_info();
+
+	if (!p->mosix.whereami)
+		error = mig_local_passto_remote(whereto, reason);
+	else if (!whereto)
+		error = mig_remote_passto_local(whereto, reason);
+	else
+		error = mig_remote_passto_remote(whereto, reason);
+
+
+	stop_storing_common_ps_info();
+	spin_lock_irq(&runqueue_lock);	/* for DPASSING (not for DMUSTBEBACK) */
+	p->mosix.dflags &= ~(DPASSING|DMUSTBEBACK);
+	spin_unlock_irq(&runqueue_lock);
+
+	if(error)
+		return (-EDIST);
+
+	task_lock(p);
+	p->mosix.whereami = whereto;
+	p->mosix.nmigs++;
+	task_unlock(p);
+	if(p->mosix.sigmig)
+		{
+			struct siginfo info;
+
+			info.si_signo = p->mosix.sigmig;
+			info.si_errno = 0;
+			info.si_code = SI_MIGRATED;
+			info.si_newplace = whereto;
+			info.si_reason = reason;
+			send_sig_info(p->mosix.sigmig, &info, p);
+		}
+	mosix_clear_statistics();
+	return(0);
+}
+
+void
+coordinate(int reason, int already_in)
+{
+	struct mosix_task *m = &current->mosix;
+	void *head;
+	int hdln;
+	int where;
+
+	while(1)
+		{
+			if(already_in)
+				{
+					if(deputy_wait(DEP_CONSIDER|REPLY, &head, &hdln))
+						goto die;
+					where = *((int *)head);
+					comm_free(head);
+					already_in = 0;
+				}
+			else if(deputy_request(DEP_CONSIDER, &reason, sizeof(reason),
+								   NULL, 0, 0, (void *)&where, -sizeof(where)))
+				{
+				die:
+					deputy_communication_failed();
+					return;
+				}
+			if(!where)
+				return;
+			if(reason && where != GOBACKHOME &&
+			   (m->whereto == GOBACKHOME || m->whereto == MUSTGOHOME))
+				{
+					where = m->whereto;
+					reason = 0;
+				}
+			if(!passto((where == GOBACKHOME || where == MUSTGOHOME) ? 0 :
+					   where, reason))
+				return;
+		}
+}
+
+int
+mig_send_request(int reason, int type)
+{
+	struct mig_request_h mrp;
+	int *nack;
+	int mfident = (current->mosix.dflags & DDEPUTY) ? COMM_MFIDENT : 0;
+	int command = MIG_REQUEST | mfident;
+	int error;
+	int len;
+
+	mrp.version = MOSIX_MIGRATION_VERSION;
+	mrp.topology = MAX_MOSIX_TOPOLOGY;
+	mrp.reason = reason;
+	mrp.personality = current->personality;
+	mrp.wp_works_ok = boot_cpu_data.wp_works_ok;
+	mrp.request_type = type;
+#ifdef CONFIG_MOSIX_DFSA
+	mrp.has_dfsa = 1;
+#else
+	mrp.has_dfsa = 0;
+#endif /* CONFIG_MOSIX_DFSA */
+
+	if(type == DEPUTY_PROBE)
+		error = comm_send(command, &mrp, sizeof(mrp), NULL, 0, 0);
+	else
+		{
+			mrp.pages_sent =
+				current->mosix.migpages ? : count_migrating_pages();
+			error = send_with_miginfo(command, &mrp, sizeof(mrp));
+		}
+	if(error)
+		return (error);
+	if ((error = comm_recv((void **)&nack, &len)) < 0)
+		return (error);
+	if (error != (MIG_REQUEST|REPLY)) {
+		error = -EDIST;
+		goto out;
+	}
+
+	/* at this point the other party *knows* us */
+	if (mfident)
+		config_set_status(comm_getpeer(current->mosix.contact));
+
+	error = *nack;		/* should be: 0 or -EDIST */
+ out:
+	comm_free((void *) nack);
+	return (error);
+}
+
+int
+mig_recv_request(struct mig_request_h **mrp)
+{
+	int type, hlen;
+	int reply = -EDIST;
+
+	if ((type = comm_recv((void **) mrp, &hlen)) < 0)
+		return (type);
+
+
+	if (type != MIG_REQUEST || hlen != sizeof(struct mig_request_h)) {
+		goto failed;
+	}
+
+	if ((*mrp)->version != MOSIX_MIGRATION_VERSION)
+		{
+			static int complained;
+
+			if(++complained < 10 || complained % 10000 == 0)
+				printk("Migration request denied: "
+					   "Incompatible versions of openMosix.\n");
+			goto failed;
+		}
+	if ((*mrp)->topology != MAX_MOSIX_TOPOLOGY)
+		{
+			static int complained;
+
+			if(++complained < 10 || complained % 10000 == 0)
+				printk("Migration request denied: Incompatible topology"
+					   " (here=%d, there=%d)\n", MAX_MOSIX_TOPOLOGY,
+					   (*mrp)->topology);
+			goto failed;
+		}
+#ifdef CONFIG_MOSIX_DFSA
+	if(!(*mrp)->has_dfsa)
+#else
+		if((*mrp)->has_dfsa)
+#endif /* CONFIG_MOSIX_DFSA */
+			{
+				static int complained;
+
+				if(++complained < 10 || complained % 10000 == 0)
+					printk("Migration request denied: "
+						   "Cannot mix DFSA and NON-DFSA kernels\n");
+				goto failed;
+			}
+
+	if ((*mrp)->request_type != DEPUTY_PROBE)
+		{
+			if (!balance_commit_mig((*mrp)->reason, (*mrp)->pages_sent))
+				goto failed;
+			current->mosix.pages_i_bring = (*mrp)->pages_sent;
+		}
+
+	return (0);
+
+ failed:
+	comm_flushdata(COMM_ALLDATA);
+	comm_free(*mrp);
+	*mrp = NULL;
+
+
+	comm_send(MIG_REQUEST|REPLY, (void *) &reply, sizeof(int), NULL, 0, 0);
+	return (reply);
+}
+
+/*
+ * mig_local_passto_remote:  migrate local -> remote
+ */
+
+static int
+mig_local_passto_remote(int whereto, int reason)
+{
+	struct task_struct *p = current;
+	struct mosix_link *mlink;
+	int error;
+	int omigpages;
+
+	if(!p->mosix.held_files && (error = mosix_rebuild_file_list()))
+		return(error);
+
+	lock_mosix();
+	write_lock_irq(&tasklist_lock);
+	p->mosix.remote_caps = current->cap_effective;
+	task_lock(p);
+	spin_lock(&runqueue_lock);
+	if(p->task_dumpable)
+	        p->mosix.dflags |= DTDUMPABLE;
+	else
+	        p->mosix.dflags &= ~DTDUMPABLE;
+	if(p->mm->dumpable)
+		p->mosix.dflags |= DDUMPABLE;
+	else
+		p->mosix.dflags &= ~DDUMPABLE;
+	p->mosix.dflags |= (DDEPUTY | DSYNC);
+	spin_unlock(&runqueue_lock);
+	task_unlock(p);
+	write_unlock_irq(&tasklist_lock);
+	unlock_mosix();
+	p->mosix.deputy_regs = ALL_REGISTERS;
+	p->mosix.pass_regs = 0;
+
+	if (!(mlink = comm_open(whereto, 0, comm_connect_timo))) {
+		error = -EDIST;
+		goto failed;
+	}
+	if (comm_use(p, mlink))
+		panic("local_passto_remote: previous contact not null");
+
+	if(!(omigpages = p->mosix.migpages))
+		p->mosix.migpages = count_migrating_pages();
+	if ((error = mig_send_request(reason, FROM_DEPUTY)))
+		{
+			p->mosix.migpages = omigpages;
+			goto failed;
+		}
+
+
+	release_migrations(whereto);
+	if (mig_do_send()) {
+		error = -EDIST;
+		p->mosix.migpages = omigpages;
+		goto failed;
+	}
+	p->mosix.migpages = omigpages;
+
+	deputy_startup();
+	return (0);
+
+ failed:
+	if(mlink)
+		comm_close(NULL);
+	undeputy(current);
+	return (error);
+}
+
+
+/*
+ * mig_remote_passto_local:  migrate remote -> local
+ */
+
+static int
+mig_remote_passto_local(int whereto, int reason)
+{
+	struct task_struct *p = current;
+	struct mig_request_h *mrp;
+	int error = 0;
+	long orlim_as;
+	long orlim_rss;
+	long orlim_stack;
+	unsigned int load_came_in = 0;
+
+	mosix_deputy_rusage(0);
+	if(obtain_mm())
+		{
+			return(-EDIST);
+		}
+
+	/* rlimits are no excuse to prevent coming back home: */
+	/* save old values for the case of failure */
+	orlim_as = p->rlim[RLIMIT_AS].rlim_cur;
+	orlim_rss = p->rlim[RLIMIT_RSS].rlim_cur;
+	orlim_stack = p->rlim[RLIMIT_STACK].rlim_cur;
+	p->rlim[RLIMIT_AS].rlim_cur = RLIM_INFINITY;
+	p->rlim[RLIMIT_RSS].rlim_cur = RLIM_INFINITY;
+	p->rlim[RLIMIT_STACK].rlim_cur = RLIM_INFINITY;
+
+	if ((error = comm_send(DEP_COME_BACK, (void *) &reason, sizeof(reason),
+						   NULL, 0, 0))) {
+		end_coming_in(error);
+		current->mosix.pages_i_bring = 0;
+		deputy_die_on_communication();
+	}
+
+	if ((error = mig_recv_request(&mrp)))
+		goto fail;
+	load_came_in = 1;
+	comm_free((void *) mrp);
+	if ((error = comm_send(MIG_REQUEST|REPLY, (void *)&error, sizeof(int),
+						   NULL, 0, 0))) {
+		end_coming_in(error);
+		current->mosix.pages_i_bring = 0;
+		deputy_die_on_communication();
+		/*NOTREACHED*/
+	}
+
+	if (!(error = mig_do_receive())) {
+		comm_close(NULL);
+		undeputy(p);
+		mosix_clear_statistics();
+#ifdef SHOW_MIGRATIONS
+		if(SHOW_MIGRATIONS)
+			printk("Wooooooooo.....\n");
+#endif /*SHOW_MIGRATIONS*/
+		end_coming_in(0);
+		current->mosix.pages_i_bring = 0;
+		if(p->mosix.dflags & DDELAYHELD)
+			{
+				p->mosix.dflags &= ~DDELAYHELD;
+				mosix_rebuild_file_list();
+			}
+		return(0);
+	}
+
+ fail:
+	p->rlim[RLIMIT_AS].rlim_cur = orlim_as;
+	p->rlim[RLIMIT_RSS].rlim_cur = orlim_rss;
+	p->rlim[RLIMIT_STACK].rlim_cur = orlim_stack;
+	exit_mm(p);
+	if(load_came_in)
+		{
+			end_coming_in(error);
+			current->mosix.pages_i_bring = 0;
+		}
+
+	return (error);
+}
+
+
+/*
+ * mig_remote_passto_remote:  migrate remote -> remote
+ *
+ * (1) open mosix_link to mig-daemon at new remote site (and use it)
+ * (2) send migration request, obtain remote's mosix_link address.
+ * (3) send DEP_PLEASE_MIGRATE request to old remote site, with "reason"
+ *     and the mosix_link address to which it should connect
+ * (4) if the reply is zero - close old mosix_link and use the new one (SUCCESS)
+ * FAILURE: if not fatal - close new connection and return error
+ *          if fatal - close connection and call deputy_die_on_communication()
+ */
+
+static int
+mig_remote_passto_remote(int whereto, int reason)
+{
+	struct task_struct *p = current;
+	struct mosix_link *newmlink = 0, *oldmlink = 0;
+	struct please_migrate_h pm;
+	int status;
+	int error;
+
+	/* connect to remote mig daemon */
+
+
+	p->mosix.pass_regs = 0;
+
+
+	if (!(newmlink = comm_open(whereto, 0, comm_connect_timo)))
+		return (-EDIST);
+
+
+	if (!(oldmlink = comm_use(p, newmlink)))
+		panic("remote_passto_remote: no previous contact");
+
+	if ((error = mig_send_request(reason, DEPUTY_PROBE)))
+		goto failed;
+
+
+	if ((error = comm_copydata((void *)&pm.ma, sizeof(pm.ma), 0)))
+		goto failed;
+
+	comm_use(p, oldmlink);
+
+
+	pm.reason = reason;
+	pm.to = whereto;
+	mosix_deputy_rusage(0);
+	if ((error = deputy_request(DEP_PLEASE_MIGRATE, &pm, sizeof(pm),
+								NULL, 0, 0, (void **)&status, -sizeof(status))))
+		goto fatal;
+	if ((error = status))
+		goto failed;
+
+	comm_use(p, newmlink);
+	comm_close(oldmlink);
+
+
+	return (0);
+
+ failed:
+	comm_use(p, oldmlink);
+	comm_close(newmlink);
+	return (error);
+
+ fatal:
+	comm_use(p, oldmlink);
+	comm_close(newmlink);
+	deputy_die_on_communication();
+	/* NOTREACHED */
+}
+
+
+void
+undeputy(struct task_struct *p)
+{
+	struct mosix_task *m = &p->mosix;
+	unsigned int myself = (p == current);/* else it is a new-son, not yet on lists */
+
+
+	if(myself)
+		{
+			spin_lock_irq(&p->sigmask_lock);
+			m->dflags &= ~DFAKESIGNAL;
+			spin_unlock_irq(&p->sigmask_lock);
+			lock_mosix();
+			write_lock_irq(&tasklist_lock);
+			task_lock(p);
+			spin_lock(&runqueue_lock);
+		}
+	if(p->mm)
+		p->mm->dumpable = (m->dflags & DDUMPABLE) != 0;
+	m->dflags &= ~(DDEPUTY|DSYNC|DDUMPABLE);
+	/* restore segment registers.
+	   FIXME: do this only if remote modified LDT */
+	loadsegment(gs, m->altgs);
+	loadsegment(fs, m->altgs);
+	if(myself)
+		{
+			spin_unlock(&runqueue_lock);
+			task_unlock(p);
+			write_unlock_irq(&tasklist_lock);
+			if(process_told(p, DREQ_HOMEWAKE))
+				{
+					process_ack(p, DREQ_HOMEWAKE);
+					wake_up(mos_to_waitp(m));
+				}
+			unlock_mosix();
+			evaluate_pending_signals_in_mosix_context();
+			absorb_deptime(m->deputytime);
+			m->deputytime = 0;
+			stop_storing_common_ps_info();
+			flush_read_cache();
+			free_ucache();
+			if(m->stay & DSTAY_FOR_MONKEY)
+				mosix_check_for_freedom_to_move();
+		}
+	else
+		{
+			if(m->contact)
+				{
+					comm_close(m->contact);
+					m->contact = NULL;
+				}
+		}
+	m->commpri = 0;
+	m->pages_i_bring = 0;
+}
+
+int
+mig_send_mm_stats(void)
+{
+	struct mm_stats_h s;
+
+	if(sizeof(struct mm_stats_h) !=
+	   offsetof(struct mm_struct, env_end) -
+	   offsetof(struct mm_struct, start_code) + sizeof(long))
+		/* something changed in the Linux header - need to fix! */
+		panic("mig_send_mm_stats");
+	memcpy((caddr_t)&s, (caddr_t)&current->mm->start_code, sizeof(s));
+	expel_progress = 1;
+	return(comm_send(MIG_MM_STATS, &s, sizeof(s), NULL, 0, 0));
+}
+
+int
+mig_send_mm_areas(void)
+{
+	struct task_struct *p = current;
+	register struct vm_area_struct *vma;
+	struct file *fp;
+	struct mmap_parameters_h m;
+
+	m.origin = (p->mosix.dflags & DDEPUTY) ? PE : p->mosix.deppe;
+	m.fixed = 1;
+	for(vma = p->mm->mmap ; vma != NULL ; vma = vma->vm_next)
+		{
+			m.addr = vma->vm_start;
+			m.len = vma->vm_end - vma->vm_start;
+			m.flags = vma->vm_flags;
+			if((fp = vma->vm_file))
+				{
+					struct inode *ip = fp->f_dentry->d_inode;
+
+					m.pgoff = vma->vm_pgoff;
+					if(p->mosix.dflags & DREMOTE)
+						{
+							m.fp = home_file(fp);
+							m.dp = ip->u.remote_i.dp;
+							m.uniq = ip->u.remote_i.unique;
+							m.isize = ip->i_size;
+							m.nopage = ip->u.remote_i.nopage;
+						}
+					else
+						{
+							m.fp = vma->vm_file;
+							m.dp = m.fp->f_dentry;
+							m.uniq = ip->i_unique;
+							m.isize = ip->i_size;
+							m.nopage = vma->vm_ops->nopage;
+						}
+				}
+			else
+				{
+					m.fp = NULL;
+					m.pgoff = 0;
+				}
+			if(comm_send(MIG_MM_AREA, &m, sizeof(m), NULL, 0, 0))
+				return(-1);
+		}
+	expel_progress = 1;
+	return(0);
+}
+
+int
+mig_send_page(unsigned long addr, int size)
+{
+	expel_progress = 1;
+	/*
+	 * Although the page is in user-space, we deliberately send it from
+	 * kernel-space to prevent requesting it from the "REMOTE"
+	 * (because we are already marked as DEPUTY...)
+	 * This is safe since we just checked that the page is there.
+	 */
+	return(comm_send(MIG_PAGE, &addr, sizeof(addr), (void *)addr, size, 0));
+}
+
+int
+mig_send_pages(void)
+{
+	int credit;
+
+	credit = run_over_dirty_pages(mig_send_page, 1);
+	return(credit);
+}
+
+int
+mig_send_fp(void)
+{
+	unlazy_fpu(current);
+	expel_progress = 1;
+	return(comm_send(has_fxsr() ? MIG_XFP : MIG_FP, &current->thread.i387,
+					 sizeof(current->thread.i387), NULL, 0, 0));
+}
+
+int
+mig_send_ldt(void)
+{
+	expel_progress = 1;
+	return(comm_send(MIG_LDT, NULL, 0,
+					 current->mm->context.segments, LDT_ENTRIES*LDT_ENTRY_SIZE, 0));
+}
+
+int
+mig_send_misc(int credit)
+{
+	struct mig_misc_h m;
+	clock_t utime, stime;
+	extern unsigned long do_it_virt(struct task_struct *, unsigned long);
+	void *hd;
+	int hdln;
+	register struct task_struct *p = current;
+	siginfo_t *forced_sigs;
+
+	m.ptrace = p->ptrace;
+	m.dflags = p->mosix.dflags & (DTRACESYS1|DTRACESYS2);
+	memcpy((caddr_t)m.debugreg, (caddr_t)p->thread.debugreg,
+		   sizeof(m.debugreg));
+	m.nice = p->nice;
+	m.caps = p->cap_effective;
+	p->mosix.remote_caps = m.caps;
+	m.it_prof_incr = p->it_prof_incr;
+	m.it_virt_incr = p->it_virt_incr;
+	if(((p->mosix.dflags & DDEPUTY) && p->mosix.deputy_regs) ||
+	   ((p->mosix.dflags & DREMOTE) &&
+		p->mosix.deputy_regs != ALL_REGISTERS)) {
+		memcpy((caddr_t)&m.regs, (caddr_t)p->mosix.altregs, sizeof(m.regs));
+	} 	/* else do not bother - DEPUTY will bring */
+
+	/* send task segment registers.
+	                                                 */
+	m.fs = p->thread.fs;
+	m.gs = p->thread.gs;
+	/* send task  limits */
+	m.rlim_cpu = p->rlim[RLIMIT_CPU];
+	m.rlim_data = p->rlim[RLIMIT_DATA];
+	m.rlim_stack = p->rlim[RLIMIT_STACK];
+	m.rlim_rss = p->rlim[RLIMIT_RSS];
+	m.rlim_as = p->rlim[RLIMIT_AS];
+#ifdef CONFIG_MOSIX_DFSA
+	m.rlim_nofile = p->rlim[RLIMIT_NOFILE];
+	m.rlim_fsz = p->rlim[RLIMIT_FSIZE];
+#endif /* CONFIG_MOSIX_DFSA */
+	m.stay = (p->mosix.stay & DNOMIGRATE) != 0;
+	if(p->mosix.dflags & DDEPUTY)
+		{
+			m.deppe = PE;
+			m.mypid = p->pid;
+			memcpy(m.features, boot_cpu_data.x86_capability,
+				   sizeof(m.features));
+		}
+	else
+		{
+			m.deppe = p->mosix.deppe;
+			m.mypid = p->mosix.mypid;
+			memcpy(m.features, p->mosix.features, sizeof(m.features));
+			m.passedtime = p->mosix.passedtime;
+		}
+	m.deputy_regs = p->mosix.deputy_regs;
+	m.deccycle = p->mosix.deccycle;
+	m.decay = p->mosix.decay;
+	m.dpolicy = p->mosix.dpolicy;
+	memcpy(m.depcost, deputy_here, sizeof(deputy_here));
+	m.depspeed = cpuspeed;
+	m.nmigs = p->mosix.nmigs + 1;
+	m.info.disclosure = p->mosix.disclosure;
+	m.info.uid = p->uid;
+	m.info.gid = p->gid;
+	m.info.pgrp = p->pgrp;
+	m.info.session = p->session;
+	memcpy(m.info.comm, p->comm, sizeof(m.info.comm));
+	m.info.tgid = p->tgid;
+	cli();
+	m.it_virt_value = p->it_virt_value;
+	m.it_prof_value = p->it_prof_value;
+	p->it_prof_value = 0;
+	p->it_virt_value = 0;
+	if(p->mosix.dflags & DDEPUTY)
+		m.passedtime = p->times.tms_utime + p->times.tms_stime;
+	utime = p->times.tms_utime;
+	stime = p->times.tms_stime;
+	m.asig.sigs = p->mosix.asig;
+	m.asig.nforced = p->mosix.nforced_sigs;
+	forced_sigs = p->mosix.forced_sigs;
+	m.pagecredit = credit;
+	m.lastxcpu = p->mosix.last_sigxcpu;
+	sti();
+	if(comm_send(MIG_MISC, &m, sizeof(m), forced_sigs,
+				 m.asig.nforced * sizeof(siginfo_t), 0))
+		goto fail;
+	comm_migration_mode(0);
+	expel_progress = 1;
+	if(comm_recv(&hd, &hdln) == (MIG_MISC|REPLY))
+		return(0); /* commit point */
+
+ fail:
+	cli();
+	p->it_prof_value = m.it_prof_value;
+	p->it_virt_value = m.it_virt_value;
+	/* maintain accurate correlation between process-times and timers: */
+	utime = p->times.tms_utime - utime;
+	stime = p->times.tms_stime - stime;
+	sti();
+	if(utime > 0)
+		{
+			extern rwlock_t xtime_lock;
+
+			write_lock_irq(&xtime_lock);
+			do_it_virt(p, utime);
+			write_unlock_irq(&xtime_lock);
+		}
+	if(!(p->mosix.dflags & DDEPUTY) && /* (DEPUTY gets it in "depticks") */
+	   utime + stime > 0)
+		absorb_deptime(utime + stime);
+	return(-1);
+}
+
+void
+neutralize_my_load(int neut)
+{
+	struct task_struct *p = current;
+
+	spin_lock_irq(&runqueue_lock);
+	if(neut)
+		{
+			run_off(p);
+			p->mosix.dflags |= DPAGEIN;	/* disabling run_on/off */
+		}
+	else if(p->mosix.dflags & DPAGEIN)
+		{
+			p->mosix.dflags &= ~DPAGEIN;
+			run_on(p);
+		}
+	spin_unlock_irq(&runqueue_lock);
+}
+
+int
+mig_do_send(void)
+{
+	int credit;	/* # of clean demand-pages */
+        if(current->mm->context.segments)
+		clear_LDT();
+
+	comm_migration_mode(1);
+	neutralize_my_load(1); /* don't count me: I'm going to disappear */
+	if(mig_send_mm_stats() || mig_send_mm_areas() ||
+	   (credit = mig_send_pages()) < 0 ||
+	   (current->used_math && mig_send_fp()) ||
+	   (current->mm->context.segments && mig_send_ldt()) ||
+	   mig_send_misc(credit))
+		{
+			comm_send(MIG_NOT_COMING, NULL, 0, NULL, 0, 0);
+			comm_migration_mode(0);
+			neutralize_my_load(0);
+			changed_my_mind_and_staying();
+			return(-1);
+		}
+	/* "comm_migration_mode(0);" was done by "mig_send_misc" */
+	if(current->mm->context.segments)
+		load_LDT(current->mm);
+	neutralize_my_load(0);
+	return(0);
+}
+
+void
+mig_do_receive_mm_stats(struct mm_stats_h *s)
+{
+	if(sizeof(struct mm_stats_h) !=
+	   offsetof(struct mm_struct, env_end) -
+	   offsetof(struct mm_struct, start_code) + sizeof(long))
+		/* something changed in the Linux header - need to fix! */
+		panic("mig_do_receive_mm_stats");
+	memcpy((caddr_t)&current->mm->start_code, (caddr_t)s, sizeof(*s));
+	current->mosix.rfreepages = 0;
+}
+
+int
+deputy_remmap(struct mmap_parameters_h *m, int dummy)
+{
+	unsigned long result;
+	unsigned long prot, flags;
+	extern asmlinkage long sys_madvise(unsigned long, size_t, int);
+
+	/* unconvert prot+flags: */
+	flags = MAP_FIXED|MAP_PRIVATE;
+	prot = 0;
+	if(m->flags & VM_GROWSDOWN)
+		flags |= MAP_GROWSDOWN;
+	if(m->flags & VM_DENYWRITE)
+		flags |= MAP_DENYWRITE;
+	if(m->flags & VM_EXECUTABLE)
+		flags |= MAP_EXECUTABLE;
+	if(m->flags & VM_READ)
+		prot |= VM_READ;
+	if(m->flags & VM_WRITE)
+		prot |= VM_WRITE;
+	if(m->flags & VM_EXEC)
+		prot |= VM_EXEC;
+	if(m->flags & VM_MAYSHARE)
+		current->mosix.dirty_bits |= MMAP_MAYSHARE;
+	deeper_sleep();
+	result = do_mmap_pgoff(m->fp, m->addr, m->len, prot, flags, m->pgoff);
+	lighter_sleep();
+	if(m->flags & VM_MAYSHARE)
+		current->mosix.dirty_bits &= ~MMAP_MAYSHARE;
+	if(m->flags & VM_READHINTMASK)
+		sys_madvise(m->addr, m->len, (m->flags & VM_SEQ_READ) ?
+					MADV_RANDOM : MADV_SEQUENTIAL);
+	return(IS_ERR((const void *)result));
+}
+
+#define	AVAILABLE_PAGES	(nr_free_pages() + page_cache_size + \
+			nr_swap_pages + swapper_space.nrpages)
+#define	VERY_LOW_ON_MEMORY (nr_swap_pages < p->mosix.pages_i_bring && \
+					AVAILABLE_PAGES <= num_physpages / 30)
+#define	I_CAN_FIT	(AVAILABLE_PAGES > p->mosix.pages_i_bring)
+
+int
+mig_do_receive_page(unsigned long addr)
+{
+	pgd_t * pgd;
+	pmd_t * pmd;
+	pte_t * pte;
+	struct page *page = NULL;
+	struct vm_area_struct *vma;
+	static int stuck_here;
+	unsigned int tries = 0;
+	long pri, mypri;
+	struct task_struct *p = current, *pp;
+	struct mm_struct *mm = p->mm;
+	int must = (p->mosix.dflags & DMUSTBEBACK);
+	static DECLARE_WAIT_QUEUE_HEAD(wait_for_someone_to_give_up);
+
+	if(!(vma = find_vma(mm, addr)))
+		{
+			comm_flushdata(COMM_ALLDATA);
+			return(-1);
+		}
+	while(VERY_LOW_ON_MEMORY)
+		{
+			stuck_here++;
+			tries++;
+			if(must ? (tries > 200 && stuck_here >= 300) :
+			   (tries > 5 && stuck_here >= 100))
+				{
+				give_up:
+					stuck_here = 0;
+					wake_up(&wait_for_someone_to_give_up);
+					printk("%s: Arrival rejected due to severe memory "
+						   "shortage.\n", desc_mostask(NULL));
+					comm_flushdata(COMM_ALLDATA);
+					return(-1);
+				}
+			mypri = ((p->mosix.dflags & DREMOTE) ? 0x20000000 : 0) +
+				(must ? 0 : 0x40000000) +
+				p->mosix.pages_i_bring + mm->rss;
+			pri = 0;
+			read_lock(&tasklist_lock);
+			for_each_task(pp)
+				if(pp != p && (pp->mosix.dflags & DINCOMING))
+					{
+						pri = ((pp->mosix.dflags & DREMOTE) ? 0x20000000 : 0) +
+							((pp->mosix.dflags & DMUSTBEBACK) ? 0 : 0x40000000) +
+							pp->mosix.pages_i_bring + pp->mm->rss;
+						if(pri >= mypri)
+							break;
+					}
+			if(must && tries > 5)
+				for_each_task(pp)
+					if((pp->mosix.dflags & (DREMOTE | DREMOTEDAEMON)) == DREMOTE &&
+					   (tries < 50 || !pp->mosix.stay))
+						{
+							mosix_add_to_whereto(pp, GOBACKHOME);
+							pri = mypri + 1;
+						}
+			read_unlock(&tasklist_lock);
+			if(pri >= mypri || (must ? (tries < 50 || stuck_here < 100) :
+								(stuck_here < 2 ||
+								 ((p->mosix.dflags & DDEPUTY) && tries < 3))))
+				{
+					sleep_on_timeout(&wait_for_someone_to_give_up, HZ/20);
+					continue;
+				}
+			if(must && I_CAN_FIT && (page = alloc_page(GFP_HIGHUSER)))
+				break;
+			goto give_up;
+		}
+	if(stuck_here)
+		{
+			wake_up(&wait_for_someone_to_give_up);
+			stuck_here = 0;
+		}
+	if(--p->mosix.pages_i_bring < 0)
+		mosix_panic("too many pages arrived");
+	p->mosix.rfreepages--;
+	if(!page && !(page = alloc_page(GFP_HIGHUSER)))
+		{
+			comm_flushdata(COMM_ALLDATA);
+			return(-1);
+		}
+	if(comm_copydata(kmap(page), PAGE_SIZE, 0))
+		{
+			kunmap(page);
+			__free_page(page);
+			return(-1);
+		}
+	kunmap(page);
+	pgd = pgd_offset(mm, addr);
+	spin_lock(&mm->page_table_lock);
+	if (!(pmd = pmd_alloc(mm, pgd, addr)))
+		{
+			spin_unlock(&mm->page_table_lock);
+			__free_page(page);
+			return(-1);
+		}
+	if (!(pte = pte_alloc(mm, pmd, addr)))
+		{
+			__free_page(page);
+			spin_unlock(&mm->page_table_lock);
+			return(-1);
+		}
+	if (!pte_none(*pte)) {
+		printk("%s-mig_do_receive_page: double page at addr 0x%x\n",
+			   desc_mostask(NULL), (int)addr);
+		__free_page(page);
+		spin_unlock(&mm->page_table_lock);
+		return(-1);
+	}
+	set_pte(pte, pte_mkdirty(mk_pte(page, vma->vm_page_prot)));
+	mm->rss++;
+	spin_unlock(&mm->page_table_lock);
+	flush_page_to_ram(page);
+	return(0);
+}
+
+void
+mig_do_receive_fp(union i387_union *i)
+{
+	current->used_math = 1;
+	unlazy_fpu(current);
+	if(has_fxsr())
+		fsave_to_fxsave(i, &current->thread.i387);
+	else
+		memcpy((caddr_t)&current->thread.i387, (caddr_t)i, sizeof(*i));
+}
+
+void
+mig_do_receive_xfp(union i387_union *i)
+{
+	current->used_math = 1;
+	unlazy_fpu(current);
+	if(has_fxsr())
+		memcpy((caddr_t)&current->thread.i387, (caddr_t)i, sizeof(*i));
+	else
+		fxsave_to_fsave(i, &current->thread.i387);
+}
+
+int
+mig_do_receive_ldt(void)
+{
+	struct mm_struct *mm = current->mm;
+        void *segments;
+
+        if (!(segments = vmalloc(LDT_ENTRIES*LDT_ENTRY_SIZE)))
+		                return(-1);
+         memset(segments, 0, LDT_ENTRIES*LDT_ENTRY_SIZE);
+        wmb();
+        mm->context.segments = segments;
+        mm->context.cpuvalid = 1UL << smp_processor_id();
+        load_LDT(mm);
+        if(comm_copydata(mm->context.segments, LDT_ENTRIES*LDT_ENTRY_SIZE, 0))
+        {
+         release_segments(mm);
+	}
+	 return(0);
+}
+
+void
+mig_do_receive_misc(struct mig_misc_h *m)
+{
+	unsigned int i;
+	int bit;
+	register struct task_struct *p = current;
+
+	if(p->mosix.dflags & DREMOTE)
+		{
+			p->ptrace |= m->ptrace;
+			p->nice = m->nice;
+			p->cap_effective = (p->cap_effective & ~REMOTE_CAPS) |
+				(m->caps & REMOTE_CAPS);
+			memcpy(p->mosix.features, m->features, sizeof(m->features));
+			task_lock(p);
+			if(m->stay)
+				p->mosix.stay |= DNOMIGRATE;
+			else
+				p->mosix.stay &= ~DNOMIGRATE;
+			task_unlock(p);
+			p->mosix.nmigs = m->nmigs;
+			remote_do_updinfo(&m->info);
+		}
+	else
+		{
+			p->ptrace &= ~PT_TRACESYS;
+			p->ptrace |= (m->ptrace & PT_TRACESYS);
+		}
+	p->mosix.dflags &= ~(DTRACESYS1|DTRACESYS2);
+	p->mosix.dflags |= m->dflags;
+	memcpy((caddr_t)p->thread.debugreg, (caddr_t)m->debugreg,
+		   sizeof(m->debugreg));
+	p->it_prof_incr = m->it_prof_incr;
+	p->it_virt_incr = m->it_virt_incr;
+	p->mosix.deputy_regs = m->deputy_regs;
+	for(bit = 1, i = 0 ; i < sizeof(struct pt_regs) / sizeof(int) ;
+		i++ , bit <<= 1)
+		if(!(m->deputy_regs & bit))
+			((int *)p->mosix.altregs)[i] = ((int *)&m->regs)[i];
+	/* recieve task segment registers
+	   FIXME: only do this if task modified the LDT.*/
+	p->mosix.altfs = m->fs;
+	p->mosix.altgs = m->gs;
+	/* recieve rlims*/
+	p->rlim[RLIMIT_CPU] = m->rlim_cpu;
+	p->rlim[RLIMIT_DATA] = m->rlim_data;
+	p->rlim[RLIMIT_STACK] = m->rlim_stack;
+	p->rlim[RLIMIT_RSS] = m->rlim_rss;
+	p->rlim[RLIMIT_AS] = m->rlim_as;
+#ifdef CONFIG_MOSIX_DFSA
+	p->rlim[RLIMIT_NOFILE] = m->rlim_nofile;
+	p->rlim[RLIMIT_FSIZE] = m->rlim_fsz;
+#endif /* CONFIG_MOSIX_DFSA */
+	if((p->mosix.deppe = m->deppe) != PE)
+		this_machine_is_favourite(p->mosix.deppe);
+	p->mosix.deccycle = m->deccycle;
+	p->mosix.decay = m->decay;
+	p->mosix.dpolicy = m->dpolicy;
+	p->mosix.mypid = m->mypid;
+	memcpy(p->mosix.depcost, m->depcost, sizeof(m->depcost));
+	p->mosix.depspeed = m->depspeed;
+	if(p->mosix.dflags & DREMOTE)
+		p->mosix.passedtime = m->passedtime;
+	else
+		p->mosix.passedtime = 0;
+	p->mosix.rpagecredit = m->pagecredit;
+	if(p->mosix.dflags & DREMOTE)
+		{
+			sprintf(p->comm, REMOTESTR2, m->mypid);
+			spin_lock_irq(&p->sigmask_lock);
+			p->mosix.asig |= m->asig.sigs;
+			spin_unlock_irq(&p->sigmask_lock);
+			while(m->asig.nforced--)
+				{
+					siginfo_t info;
+
+					comm_copydata(&info, sizeof(info), 0);
+					force_sig_info(info.si_signo, &info, p);
+				}
+		}
+	cli();
+	p->it_virt_value = m->it_virt_value;
+	p->it_prof_value = m->it_prof_value;
+	p->mosix.last_sigxcpu = m->lastxcpu;
+	sti();
+	if(p->mosix.dflags & DDEPUTY)
+		deputy_analyse_remote_signals(&m->asig);
+}
+
+int
+mig_do_receive(void)
+{
+	struct mosix_task *m = &current->mosix;
+	int type;
+	void *head;
+	int hlen;
+	int (*mmap_func)(struct mmap_parameters_h *, int);
+	unsigned int got_not_coming = 0;
+
+	spin_lock_irq(&runqueue_lock);
+	m->dflags |= DINCOMING;
+	spin_unlock_irq(&runqueue_lock);
+	current->used_math = 0;
+	while(1) {
+		switch(type = comm_recv(&head, &hlen)) {
+		case MIG_MM_STATS:
+			mig_do_receive_mm_stats((struct mm_stats_h *)head);
+			break;
+		case MIG_MM_AREA:
+			if(m->dflags & DREMOTE)
+				mmap_func = remote_mmap;
+			else
+				mmap_func = deputy_remmap;
+			if(mmap_func((struct mmap_parameters_h *)head, 1))
+			{
+				comm_free(head);
+				goto fail;
+			}
+			break;
+		case MIG_PAGE:
+			if(mig_do_receive_page(*((unsigned long *)head)))
+			{
+				comm_free(head);
+				goto fail;
+			}
+			break;
+		case MIG_FP:
+			mig_do_receive_fp((union i387_union *)head);
+			break;
+		case MIG_XFP:
+			mig_do_receive_xfp((union i387_union *)head);
+			break;
+		case MIG_LDT:
+			if(mig_do_receive_ldt())
+			{
+				comm_free(head);
+				goto fail;
+			}
+			break;
+		case MIG_MISC:
+			mig_do_receive_misc((struct mig_misc_h *)head);
+			comm_free(head);
+			spin_lock_irq(&runqueue_lock);
+			m->dflags &= ~DINCOMING;
+			spin_unlock_irq(&runqueue_lock);
+			flush_tlb();	/* for all the new pages */
+			comm_send(MIG_MISC|REPLY, NULL, 0, NULL, 0, 0);
+			return(0);
+		case MIG_NOT_COMING:
+			got_not_coming = 1;
+			goto fail;
+		default:
+			if(m->dflags & DDEPUTY)
+				deputy_communication_failed();
+			comm_free(head);
+			goto fail;
+		}
+		comm_free(head);
+		if((m->dflags & DREMOTE) && (mosadmin_mode_block || !NPE))
+			goto fail;
+	}
+ fail:
+
+	if(type >= 0)
+		comm_flushdata(COMM_ALLDATA);
+	spin_lock_irq(&runqueue_lock);
+	m->dflags &= ~DINCOMING;
+	spin_unlock_irq(&runqueue_lock);
+	if((m->dflags & DDEPUTY) && !got_not_coming)
+	{
+		/* receiving all the debris can take time and
+		   someone may need the memory meanwhile! */
+		current->mosix.pages_i_bring = 0;
+		do_munmap(current->mm, 0, PAGE_OFFSET);
+		while((type = comm_recv(&head, &hlen)) >= 0 &&
+		      type != MIG_NOT_COMING)
+		{
+			comm_free(head);
+			comm_flushdata(COMM_ALLDATA);
+			if(type == MIG_MISC)
+				/* send anything but MIG_MISC|REPLY: */
+				/* they will then send MIG_NOT_COMING! */
+				comm_send(DEP_SYNC, NULL, 0, NULL, 0, 0);
+		}
+	}
+	return(-1);
+}
+
+void
+mig_set_lock(int lock)
+{
+	struct task_struct *p = current;
+
+	task_lock(p);
+	if (lock)
+		p->mosix.stay |= DNOMIGRATE;
+	else
+		p->mosix.stay &= ~DNOMIGRATE;
+	task_unlock(p);
+	if(current->mosix.dflags & DDEPUTY)
+		deputy_request(DEP_UPDATE_LOCK, &lock, sizeof(int), NULL, 0, 0,
+					   NULL, 0);
+}
+
+int
+remote_set_lock(int *lockp)
+{
+	mig_set_lock(*lockp);
+	comm_free(lockp);
+	return(comm_send(DEP_UPDATE_LOCK|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+void
+mig_set_migfilter(int migfilter)
+{
+	struct task_struct *p = current;
+
+	task_lock(p);
+	if (migfilter)
+		p->mosix.dflags |= DMIGFILTER;
+	else
+		p->mosix.dflags &= ~DMIGFILTER;
+	task_unlock(p);
+	if(current->mosix.dflags & DDEPUTY)
+		deputy_request(DEP_UPDATE_MIGFILTER, &migfilter, sizeof(int), NULL, 0, 0,
+					   NULL, 0);
+}
+
+int
+remote_set_migfilter(int *migfilterp)
+{
+	mig_set_migfilter(*migfilterp);
+	comm_free(migfilterp);
+	return(comm_send(DEP_UPDATE_MIGFILTER|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+void
+mig_set_migpolicy(int migpolicy)
+{
+	struct task_struct *p = current;
+
+	task_lock(p);
+	p->mosix.mask.migpolicy = migpolicy;
+	task_unlock(p);
+	if(current->mosix.dflags & DDEPUTY)
+		deputy_request(DEP_UPDATE_MIGPOLICY, &migpolicy, sizeof(int), NULL, 0, 0,
+					   NULL, 0);
+}
+
+int
+remote_set_migpolicy(int *migpolicyp)
+{
+	mig_set_migpolicy(*migpolicyp);
+	comm_free(migpolicyp);
+	return(comm_send(DEP_UPDATE_MIGPOLICY|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+void
+mig_set_mignodes(uint32_t mignodes)
+{
+	struct task_struct *p = current;
+
+	task_lock(p);
+	p->mosix.mask.mignodes = mignodes;
+	task_unlock(p);
+	if(current->mosix.dflags & DDEPUTY)
+		deputy_request(DEP_UPDATE_MIGNODES, &mignodes, sizeof(int), NULL, 0, 0,
+					   NULL, 0);
+}
+
+int
+remote_set_mignodes(uint32_t *mignodesp)
+{
+	mig_set_mignodes(*mignodesp);
+	comm_free(mignodesp);
+	return(comm_send(DEP_UPDATE_MIGNODES|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+void
+mig_set_miggroup(int miggroup)
+{
+        struct task_struct *p = current;
+
+        task_lock(p);
+        p->mosix.mask.miggroup = miggroup;
+        task_unlock(p);
+        if(current->mosix.dflags & DDEPUTY)
+                deputy_request(DEP_UPDATE_MIGPOLICY, &miggroup, sizeof(int), NULL, 0, 0,
+                                           NULL, 0);
+}
+
+int
+remote_set_miggroup(int *miggroup)
+{
+        mig_set_miggroup(*miggroup);
+        comm_free(miggroup);
+        return(comm_send(DEP_UPDATE_MIGGROUP|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+
+
+
+int
+mig_migrate(int to)
+{
+	if (to > 0)
+		return(passto(to, 0) ?
+			   (mos_to_net(to, NULL) ? -ENETUNREACH : -ENXIO) : 0);
+
+	switch(to)
+	{
+	case DM_GOBACKHOME:
+		return(passto(GOBACKHOME, 0) ? -EDIST : 0);
+	case DM_BALANCE:
+		if(current->mosix.dflags & DDEPUTY)
+			coordinate(0, 0);
+		else
+			consider(0, NULL);
+		return(0);
+	}
+	return(-EINVAL);
+}
+
+int
+count_migrating_pages(void)
+{
+	return(run_over_dirty_pages(NULL, 0));
+}
